//////////////////////////////////////////////////////
// Direct3D.h
//////////////////////////////////////////////////////

#pragma once

#include <d3d8.h>
#include <D3dx8tex.h>

class CDirect3D
{
protected:
    LPDIRECT3D8 m_pD3D;
    LPDIRECT3DDEVICE8 m_pD3DDevice;
    IDirect3DSurface8* m_pBackBuffer;
    HWND m_hWnd;
    char m_szErrorMsg[256];
    IDirect3DSurface8* m_pTownExtTileSurface;
    IDirect3DSurface8* m_pTownIntTileSurface;
    IDirect3DSurface8* m_pDungeonTileSurface;
    IDirect3DSurface8* m_pWildernessTileSurface;
    IDirect3DSurface8* m_pCurrentTileSurface;
    IDirect3DSurface8* m_pPlayerTile;
    IDirect3DTexture8* m_pTexture;
    IDirect3DTexture8* m_pMonsterTexture[4];

public:
    CDirect3D(void);
    ~CDirect3D(void);
    void SetWindowHandle(HWND hWnd);
    HRESULT InitD3D(void);
    LPDIRECT3DDEVICE8 GetDevice(void);
    IDirect3DSurface8* GetBackBuffer(void);
    char* GetErrorString(void);
    IDirect3DSurface8* GetTownExtTileSurface();
    IDirect3DSurface8* GetTownIntTileSurface();
    IDirect3DSurface8* GetDungeonTileSurface();
    IDirect3DSurface8* GetWildernessTileSurface();
    IDirect3DSurface8* GetCurrentTileSurface();
    IDirect3DSurface8* GetPlayerTile();
    void SetCurrentTileSurface(IDirect3DSurface8* pSurface);
    IDirect3DTexture8* GetTexture();
    IDirect3DTexture8* GetMonsterTexture(int iFrame);
    void CreateMonsterTextures(char* idle1, 
        char* idle2, char* attack, char* hit);
    void ReleaseMonsterTextures();
    void CleanUp(void);

private:
    HRESULT CreateD3DObject(void);
    HRESULT CheckDisplayMode(void);
    HRESULT CreateD3DDevice(void);
    HRESULT CreateSurfaces(void);
};
