//////////////////////////////////////////////////////
// DirectSound.h
//////////////////////////////////////////////////////

#pragma once

#include <dsound.h>
#include <D3dx8tex.h>
#include "Wave.h" 
#include "Constants.h"

class CDirectSound
{
protected:
    IDirectSound8* m_pDirectSoundObj;
    IDirectSoundBuffer* m_pMonsterDieSound;
    IDirectSoundBuffer* m_pMonsterHitSound;
    IDirectSoundBuffer* m_pPlayerHitSound;
    IDirectSoundBuffer* m_pFootstepSound;
    IDirectSoundBuffer* m_pItemOpenSound;
    HWND m_hWnd;
    char m_szErrorMsg[256];
 
public:
    CDirectSound(void);
    ~CDirectSound(void);
    void SetWindowHandle(HWND hWnd);
    HRESULT InitDirectSound(void);
    char* GetErrorString(void);
    HRESULT PlaySound(int iSoundID);

private:
    HRESULT CreateSoundBuffers(void);
    void CleanUp(void);
    HRESULT LoadSoundEffect(char* pstrFileName, 
        IDirectSoundBuffer** ppSoundBuf);
};
