////////////////////////////////////////////////////////
// FirstTown.cpp
////////////////////////////////////////////////////////

#include <d3d8.h>
#include "constants.h"
#include "MyEngine.h"
#include "FirstTown.h"

extern CMyEngine g_Engine;

// Quest flags.
BOOL bSpokeToGrewell = FALSE;
BOOL bSpokeToWillam = FALSE;
BOOL bWillamQuestComplete = FALSE;
BOOL bHasWillamKey = FALSE;

////////////////////////////////////////////////////////
// HandleFirstTown()
////////////////////////////////////////////////////////
void HandleFirstTown()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case HOUSE01FRONTDOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(HOUSE01FRONTDOOR - 1);
        g_Engine.OpenMapFiles("FirstTownHouse01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNHOUSE01ROOM01);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownIntTileSurface()); 
        g_Engine.ResetAnimation();
        break;
    case FIRSTTOWNINNFRONTDOOR:
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNFRONTDOOR + 1);
        g_Engine.SaveGame(FALSE);
        g_Engine.OpenMapFiles("FirstTownInnRoom01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM01);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownIntTileSurface());
        g_Engine.ResetAnimation();
        break;
    case HOUSE02FRONTDOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(HOUSE02FRONTDOOR + 1);
        g_Engine.OpenMapFiles("FirstTownHouse02Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNHOUSE02ROOM01);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownIntTileSurface());
        g_Engine.ResetAnimation();
        break;
    case ARMORERFRONTDOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(ARMORERFRONTDOOR + 1);
        g_Engine.OpenMapFiles("FirstTownArmorer.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNARMORER);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownIntTileSurface());
        g_Engine.ResetAnimation();
        break;
    case POTIONSFRONTDOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(POTIONSFRONTDOOR + 1);
        g_Engine.OpenMapFiles("FirstTownPotions.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNPOTIONS);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownIntTileSurface());
        g_Engine.ResetAnimation();
        break;
    case GANJEKENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(902);
        g_Engine.OpenMapFiles("GanjekWilds.map", FALSE);
        g_Engine.SetCurrentMap(GANJEKWILDS);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetWildernessTileSurface());
        g_Engine.ResetAnimation();
        break;
    case DUNGEON02ENTRANCE:
        g_Engine.SaveGame(FALSE);
        if (bSpokeToWillam)
        {
            g_Engine.GetPlayer()->SetSector(DUNGEON02EXIT - MAPCOLUMNCOUNT);
            g_Engine.OpenMapFiles("FirstTownDungeon02.map", FALSE);
            g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON02);
            g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
                (g_Engine.GetCDirect3DObj()->GetDungeonTileSurface());
            g_Engine.ResetAnimation();
        }
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownHouse01Room01()
////////////////////////////////////////////////////////
void HandleFirstTownHouse01Room01()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case HOUSE01FRONTDOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(HOUSE01FRONTDOOR + 1);
        g_Engine.OpenMapFiles("FirstTown.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWN);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownExtTileSurface());
        g_Engine.ResetAnimation();
        break;
    case HOUSE01ROOM01DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(HOUSE01ROOM01DOOR - 1);
        g_Engine.OpenMapFiles("FirstTownHouse01Room02.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNHOUSE01ROOM02);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownHouse01Room02()
////////////////////////////////////////////////////////
void HandleFirstTownHouse01Room02()
{
    if (g_Engine.GetPlayer()->GetSector() == HOUSE01ROOM01DOOR)
    {
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(HOUSE01ROOM01DOOR + 1);
        g_Engine.OpenMapFiles("FirstTownHouse01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNHOUSE01ROOM01);
        g_Engine.ResetAnimation();
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownInnRoom01()
////////////////////////////////////////////////////////
void HandleFirstTownInnRoom01()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case FIRSTTOWNINNFRONTDOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNFRONTDOOR - 1);
        g_Engine.OpenMapFiles("FirstTown.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWN);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownExtTileSurface());
        g_Engine.ResetAnimation();
        break;
    case FIRSTTOWNINNROOM02DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM02DOOR - 1);
        g_Engine.OpenMapFiles("FirstTownInnRoom02.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM02);
        g_Engine.ResetAnimation();
        break;
    case FIRSTTOWNINNROOM03DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM03DOOR + 1);
        g_Engine.OpenMapFiles("FirstTownInnRoom03.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM03);
        g_Engine.ResetAnimation();
        break;
    case FIRSTTOWNINNROOM04DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM04DOOR - 1);
        g_Engine.OpenMapFiles("FirstTownInnRoom04.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM04);
        g_Engine.ResetAnimation();
        break;
    case FIRSTTOWNINNROOM05DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM05DOOR + 1);
        g_Engine.OpenMapFiles("FirstTownInnRoom05.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM05);
        g_Engine.ResetAnimation();
        break;
    case FIRSTTOWNINNROOM06STAIRS:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM06STAIRS - 
            MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownInnRoom06.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM06);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownInnRoom02()
////////////////////////////////////////////////////////
void HandleFirstTownInnRoom02()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case FIRSTTOWNINNROOM02DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM02DOOR + 1);
        g_Engine.OpenMapFiles("FirstTownInnRoom01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM01);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownInnRoom03()
////////////////////////////////////////////////////////
void HandleFirstTownInnRoom03()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case FIRSTTOWNINNROOM03DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM03DOOR - 1);
        g_Engine.OpenMapFiles("FirstTownInnRoom01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM01);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownInnRoom04()
////////////////////////////////////////////////////////
void HandleFirstTownInnRoom04()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case FIRSTTOWNINNROOM04DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM04DOOR + 1);
        g_Engine.OpenMapFiles("FirstTownInnRoom01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM01);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownInnRoom05()
////////////////////////////////////////////////////////
void HandleFirstTownInnRoom05()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case FIRSTTOWNINNROOM05DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM05DOOR - 1);
        g_Engine.OpenMapFiles("FirstTownInnRoom01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM01);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownInnRoom06()
////////////////////////////////////////////////////////
void HandleFirstTownInnRoom06()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case FIRSTTOWNINNROOM07DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM07DOOR - 
            MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownInnRoom07.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM07);
        g_Engine.ResetAnimation();
        break;
    case FIRSTTOWNINNROOM06STAIRS:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM05DOOR - 1);
        g_Engine.OpenMapFiles("FirstTownInnRoom01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM01);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownInnRoom07()
////////////////////////////////////////////////////////
void HandleFirstTownInnRoom07()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case FIRSTTOWNINNROOM07DOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(FIRSTTOWNINNROOM07DOOR + 
            MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownInnRoom06.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNINNROOM06);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownHouse02Room01()
////////////////////////////////////////////////////////
void HandleFirstTownHouse02Room01()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case HOUSE02FRONTDOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(HOUSE02FRONTDOOR - 1);
        g_Engine.OpenMapFiles("FirstTown.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWN);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownExtTileSurface());
        g_Engine.ResetAnimation();
        break;
    case HOUSE02ROOM02ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.OpenMapFiles("FirstTownHouse02Room02.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNHOUSE02ROOM02);
        g_Engine.ResetAnimation();
        break;
        }
}

////////////////////////////////////////////////////////
// HandleFirstTownArmorer()
////////////////////////////////////////////////////////
void HandleFirstTownArmorer()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case ARMORERFRONTDOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(ARMORERFRONTDOOR - 1);
        g_Engine.OpenMapFiles("FirstTown.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWN);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownExtTileSurface());
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownPotions()
////////////////////////////////////////////////////////
void HandleFirstTownPotions()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case POTIONSFRONTDOOR:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(POTIONSFRONTDOOR - 1);
        g_Engine.OpenMapFiles("FirstTown.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWN);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownExtTileSurface());
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownHouse02Room02()
////////////////////////////////////////////////////////
void HandleFirstTownHouse02Room02()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case HOUSE02ROOM02ENTRANCE - 2:
        g_Engine.SaveGame(FALSE);
        g_Engine.OpenMapFiles("FirstTownHouse02Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNHOUSE02ROOM01);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM01ENTRANCE + MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetDungeonTileSurface());
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room01()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room01()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM01ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ENTRANCE - MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownHouse02Room02.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNHOUSE02ROOM02);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownIntTileSurface());
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM02ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room02.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM02);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM07ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM07ENTRANCE - 1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room07.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM07);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM09ENTRANCE1:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM09ENTRANCE1 + 1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room09.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM09);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM09ENTRANCE2:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM09ENTRANCE2 + 1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room09.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM09);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM09ENTRANCE3:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM09ENTRANCE3 - MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room09.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM09);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM10ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM10ENTRANCE - MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room10.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM10);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM11ENTRANCE1:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM11ENTRANCE1 - MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room11.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM11);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM11ENTRANCE2:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM11ENTRANCE2 - 1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room11.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM11);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM11ENTRANCE3:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM11ENTRANCE3 - 1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room11.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM11);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room02()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room02()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM02ENTRANCE - 2:
        g_Engine.SaveGame(FALSE);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM03ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM03ENTRANCE - MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room03.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM03);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM04ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM04ENTRANCE + MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room04.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM04);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM05ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM05ENTRANCE - MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room05.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM05);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM06ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM06ENTRANCE - MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room06.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM06);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room03()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room03()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM03ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM03ENTRANCE + MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room02.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM02);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room04()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room04()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM04ENTRANCE - MAPCOLUMNCOUNT*2:
        g_Engine.SaveGame(FALSE);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room02.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM02);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room05()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room05()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM05ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM05ENTRANCE + MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room02.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM02);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room06()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room06()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM06ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM06ENTRANCE + MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room02.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM02);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room07()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room07()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM07ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM07ENTRANCE + 1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room08()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room08()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM08ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM08ENTRANCE + MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room10.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM10);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room09()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room09()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM09ENTRANCE1:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM09ENTRANCE1 -  1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM09ENTRANCE2:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM09ENTRANCE2 -  1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM09ENTRANCE3:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM09ENTRANCE3 + MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room10()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room10()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM10ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM10ENTRANCE + MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM08ENTRANCE:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM08ENTRANCE - MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room08.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM08);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon01Room11()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon01Room11()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON01ROOM11ENTRANCE1:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM11ENTRANCE1 + MAPCOLUMNCOUNT);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM11ENTRANCE2:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM11ENTRANCE2 + 1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.ResetAnimation();
        break;
    case DUNGEON01ROOM11ENTRANCE3:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON01ROOM11ENTRANCE3 + 1);
        g_Engine.OpenMapFiles("FirstTownDungeon01Room01.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWNDUNGEON01ROOM01);
        g_Engine.ResetAnimation();
        break;
    }
}

////////////////////////////////////////////////////////
// HandleFirstTownDungeon02()
////////////////////////////////////////////////////////
void HandleFirstTownDungeon02()
{
    switch (g_Engine.GetPlayer()->GetSector())
    {
    case DUNGEON02EXIT:
        g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->
            SetSector(DUNGEON02ENTRANCE - 1);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownExtTileSurface());
        g_Engine.OpenMapFiles("FirstTown.map", FALSE);
        g_Engine.SetCurrentMap(FIRSTTOWN);
        g_Engine.ResetAnimation();
        break;
    }
}

//////////////////////////////////////////////////////
// HandleFennelGridrock()
//////////////////////////////////////////////////////
void HandleFennelGridrock()
{
    g_Engine.TurnOnPlaque(
"I'm Fennel Gridrock, a guard\n\
here at First Town. I hope you\n\
enjoy your stay.");
}

//////////////////////////////////////////////////////
// HandleUrisYamdolf()
//////////////////////////////////////////////////////
void HandleUrisYamdolf()
{
    if (bSpokeToGrewell)
        g_Engine.TurnOnPlaque(
"I'm Uris Yamdolf, a guard\n\
here at First Town. It's nice to\n\
have you here helping\n\
the citizens.");
    else
        g_Engine.TurnOnPlaque(
"I'm Uris Yamdolf, a guard\n\
here at First Town. You're Jasper,\n\
right? You're supposed to talk\n\
with Grewell Pessle as soon\n\
as you can.");
}

//////////////////////////////////////////////////////
// HandleGrewellPessle()
//////////////////////////////////////////////////////
void HandleGrewellPessle()
{
    if (!bSpokeToGrewell)
    {
        g_Engine.TurnOnPlaque(
"I'm Grewell Pessle, one of the\n\
town Councilmen. Willam Groves'\n\
son lost his puppy. Find the puppy,\n\
and I'll give you something useful\n\
Speak to Willam for more\n\
information about the puppy.");
        bSpokeToGrewell = TRUE;
    }
    else if (bSpokeToGrewell && !bWillamQuestComplete)
        g_Engine.TurnOnPlaque( 
"You're supposed to be finding\n\
that puppy, remember? Talk to\n\
Willam Groves.");
    else if (bWillamQuestComplete && !bHasWillamKey)
    {
        g_Engine.TurnOnPlaque(
"Great job finding the puppy!\n\
Here's the key you\n\
need to get into the\n\
abandoned house.");
        bHasWillamKey = TRUE;
    }
    else if (bHasWillamKey)
    {
        g_Engine.TurnOnPlaque(
"Thanks for your help\n\
finding the puppy.");
        bHasWillamKey = TRUE;
    }
}

//////////////////////////////////////////////////////
// HandleWillamGroves()
//////////////////////////////////////////////////////
void HandleWillamGroves()
{
    if (bSpokeToWillam && !bWillamQuestComplete)
        g_Engine.TurnOnPlaque(
"My son is very unhappy.\n\
Please find his puppy.");
    else if (bSpokeToGrewell && !bSpokeToWillam)
    {
        g_Engine.TurnOnPlaque(
"Hi, Jasper. Grewell told me\n\
that he spoke to you. I'm Willam\n\
Groves. My son said he last saw\n\
his dog somewhere in the\n\
northwest of the town.");
        bSpokeToWillam = TRUE;
    }
    else if (bWillamQuestComplete)
        g_Engine.TurnOnPlaque(
"Hi again, Jasper! My son is\n\
thrilled to have his puppy back.\n\
Did you see Grewell Passle\n\
about your reward?");
    else
        g_Engine.TurnOnPlaque(
"Hello, stranger.\n\
I'm Willam Groves.");
}

//////////////////////////////////////////////////////
// FinishWillamQuest()
//////////////////////////////////////////////////////
void FinishWillamQuest()
{
    if (!bWillamQuestComplete)
    {
        g_Engine.TurnOnPlaque("You find a small puppy,\n\
which you tuck safely\nunder your arm.");
        bWillamQuestComplete = TRUE;
    }
    else
        g_Engine.TurnOnPlaque("You find nothing.");
}

//////////////////////////////////////////////////////
// OpenAbandonedHouse()
//////////////////////////////////////////////////////
BOOL OpenAbandonedHouse()
{
    if (bHasWillamKey)
    {
        g_Engine.TurnOnPlaque(
"You use the key you got\n\
from Grewell Pessle to\n\
open the door.");
        return TRUE;
    }
    g_Engine.TurnOnPlaque("You need a special key.");
    return FALSE;
}

//////////////////////////////////////////////////////
// HandleArstinBlack()
//////////////////////////////////////////////////////
void HandleArstinBlack()
{
    g_Engine.TurnOnPlaque(
"I'm Arstin Black, the\n\
proprietor of this shop.\n\
Would you like to buy a\n\
potion for 8 gold pieces?\n\
(Y/N)");
    g_Engine.SetPurchasePrice(8);
}

//////////////////////////////////////////////////////
// HandlePaltumGanges()
//////////////////////////////////////////////////////
void HandlePaltumGanges()
{
    g_Engine.TurnOnPlaque(
"I'm Paltum Ganges, the\n\
proprietor of this shop.\n\
Would you like to buy\n\
level 1 armor for 100 gold pieces?\n\
(Y/N)");
    g_Engine.SetPurchasePrice(100);
    g_Engine.SetNewArmorLevel(1);
}

//////////////////////////////////////////////////////
// HandleBilliamAberton()
//////////////////////////////////////////////////////
void HandleBilliamAberton()
{
    g_Engine.TurnOnPlaque(
"I'm Billiam Aberton, the\n\
proprietor of this inn.\n\
Would you like to stay\n\
the night for 6 gold pieces?\n\
(Y/N)");
    g_Engine.SetPurchasePrice(6);
}
