//////////////////////////////////////////////////////
// MyEngine.cpp
//////////////////////////////////////////////////////

#include "myengine.h"

//////////////////////////////////////////////////////
// CMyEngine()
//////////////////////////////////////////////////////
CMyEngine::CMyEngine(char* pstrMap, int iMapType, int iSector) :
    CEngine(pstrMap, iMapType, iSector)
{
    m_bBuyingPotion = FALSE;
    m_bBuyingArmor = FALSE;
    m_bBuyingWeapon = FALSE;
    m_bRentingRoom = FALSE;
}

//////////////////////////////////////////////////////
// ~CMyEngine()
//////////////////////////////////////////////////////
CMyEngine::~CMyEngine(void)
{
}

//////////////////////////////////////////////////////
// RespondToPlayerLocation()
//////////////////////////////////////////////////////
void CMyEngine::RespondToPlayerLocation()
{
    switch (m_iCurrentMap)
    {
        case FIRSTTOWN:
            HandleFirstTown();
            break;
        case FIRSTTOWNHOUSE01ROOM01:
            HandleFirstTownHouse01Room01();
            break;
        case FIRSTTOWNHOUSE01ROOM02:
            HandleFirstTownHouse01Room02();
            break;
        case FIRSTTOWNINNROOM01:
            HandleFirstTownInnRoom01();
            break;
        case FIRSTTOWNINNROOM02:
            HandleFirstTownInnRoom02();
            break;
        case FIRSTTOWNINNROOM03:
            HandleFirstTownInnRoom03();
            break;
        case FIRSTTOWNINNROOM04:
            HandleFirstTownInnRoom04();
            break;
        case FIRSTTOWNINNROOM05:
            HandleFirstTownInnRoom05();
            break;
        case FIRSTTOWNINNROOM06:
            HandleFirstTownInnRoom06();
            break;
        case FIRSTTOWNINNROOM07:
            HandleFirstTownInnRoom07();
            break;
        case FIRSTTOWNHOUSE02ROOM01:
            HandleFirstTownHouse02Room01();
            break;
        case FIRSTTOWNARMORER:
            HandleFirstTownArmorer();
            break;
        case FIRSTTOWNPOTIONS:
            HandleFirstTownPotions();
            break;
        case GANJEKWILDS:
            HandleGanjek();
            break;
        case FIRSTTOWNHOUSE02ROOM02:
            HandleFirstTownHouse02Room02();
            break;
        case FIRSTTOWNDUNGEON01ROOM01:
            HandleFirstTownDungeon01Room01();
            break;
        case FIRSTTOWNDUNGEON01ROOM02:
            HandleFirstTownDungeon01Room02();
            break;
        case FIRSTTOWNDUNGEON01ROOM03:
            HandleFirstTownDungeon01Room03();
            break;
        case FIRSTTOWNDUNGEON01ROOM04:
            HandleFirstTownDungeon01Room04();
            break;
        case FIRSTTOWNDUNGEON01ROOM05:
            HandleFirstTownDungeon01Room05();
            break;
        case FIRSTTOWNDUNGEON01ROOM06:
            HandleFirstTownDungeon01Room06();
            break;
        case FIRSTTOWNDUNGEON01ROOM07:
            HandleFirstTownDungeon01Room07();
            break;
        case FIRSTTOWNDUNGEON01ROOM08:
            HandleFirstTownDungeon01Room08();
            break;
        case FIRSTTOWNDUNGEON01ROOM09:
            HandleFirstTownDungeon01Room09();
            break;
        case FIRSTTOWNDUNGEON01ROOM10:
            HandleFirstTownDungeon01Room10();
            break;
        case FIRSTTOWNDUNGEON01ROOM11:
            HandleFirstTownDungeon01Room11();
            break;
        case FIRSTTOWNDUNGEON02:
            HandleFirstTownDungeon02();
			break;
		case MAXIMCASTLE:
			HandleMaximCastle();
			break;
		case VERISIA:
			HandleVerisia();
			break;
		case VERISIAVILLE:
			HandleVerisiaville();
			break;
		case ARMORSHOP:
			HandleArmorShop();
			break;
		case POTIONSHOP:
			HandlePotionShop();
			break;
		case INN:
			HandleInn();
			break;

    }
}

//////////////////////////////////////////////////////
// HandleNPC()
//////////////////////////////////////////////////////
void CMyEngine::HandleNPC(int iNPC)
{
    char name[128];
    strcpy(name, m_People.GetPerson(iNPC)->GetName());
    strcpy(name, &name[1]);
    name[strlen(name) - 1] = 0;
    if (strcmp(name, "Fennel Gridrock") == 0)
        HandleFennelGridrock();
    else if (strcmp(name, "Uris Yamdolf") == 0)
        HandleUrisYamdolf();
    else if (strcmp(name, "Grewell Pessle") == 0)
        HandleGrewellPessle();
    else if (strcmp(name, "Willam Groves") == 0)
        HandleWillamGroves();
    else if (strcmp(name, "Arstin Black") == 0)
    {
        HandleArstinBlack();
        m_bBuyingPotion = TRUE;
    }
    else if (strcmp(name, "Paltum Ganges") == 0)
    {
        HandlePaltumGanges();
        m_bBuyingArmor = TRUE;
    }
    else if (strcmp(name, "Billiam Aberton") == 0)
    {
        HandleBilliamAberton();
        m_bRentingRoom = TRUE;
    }
	else if (strcmp(name, "Brucius Maximus") == 0)
	{
		HandleBruciusMaximus();

	}
	else if (strcmp(name, "Swash Buckler") == 0)
	{
		HandleArmorSeller();
		m_bBuyingArmor = TRUE;  //this is the armor seller
	}//end armor seller
	else if (strcmp(name, "Sleepius Napnap") == 0)
	{
		HandleInnKeeper();
		m_bRentingRoom = TRUE;
	}//end inn keeper
	else if (strcmp(name, "Healemup") == 0)
	{
		HandlePotionSeller();
		m_bBuyingPotion = TRUE;
	}//end potion seller
	else if (strcmp(name, "Malfus") == 0)
	{
		HandleMalfus();
	} //end Malfus
	else if (strcmp(name, "Gypsum") == 0)
	{
		HandleGypsum();
	}
	else if (strcmp(name, "Elenbogus") == 0)
	{
		HandleElenbogus();
	}//end elenbogus
	else if (strcmp(name, "Samson") == 0)
	{
		HandleSamson();
	}//end Samson
	else if (strcmp(name, "Jarek") == 0)
	{
		HandleJarek();
	}
	else if (strcmp(name, "Winfred") == 0)
	{
		HandleWinfred();
	}//end winfred
	else if (strcmp(name, "Georgius") == 0)
	{
		HandleGeorgius();
	}//end georgius
	else if (strcmp(name, "Coriandor") == 0)
	{
		HandleCoriandor();
	}//end coriandor
	else if (strcmp(name, "Jenson") == 0)
	{
		HandleJenson();
	}//end jenson
	else if (strcmp(name, "Corry") == 0)
	{
		HandleCorry();
	}//end corey
    else
        CEngine::HandleNPC(iNPC);
}

//////////////////////////////////////////////////////
// HandleContainer()
//////////////////////////////////////////////////////
BOOL CMyEngine::HandleContainer(int iSector)
{
    if (m_iCurrentMap == FIRSTTOWNDUNGEON02 && 
            m_Sectors[iSector] == BARREL_DUN)
    {
        FinishWillamQuest();
        return TRUE;
    }
    else
        return CEngine::HandleContainer(iSector);
}

//////////////////////////////////////////////////////
// HandleDoor()
//////////////////////////////////////////////////////
BOOL CMyEngine::HandleDoor(int iSector)
{
    if (m_iCurrentMap == FIRSTTOWN && iSector == HOUSE02FRONTDOOR)
    {
        BOOL bOpen = OpenAbandonedHouse();
        return bOpen;
    }
    return CEngine::HandleDoor(iSector);
}

//////////////////////////////////////////////////////
// IsMonsterLocation()
//////////////////////////////////////////////////////
BOOL CMyEngine::IsMonsterLocation()
{
    switch (m_iCurrentMap)
    {
    case VERISIA:
        return TRUE;
		//case GANJEKWILDS:  return TRUE;
    }
    return FALSE;
}

//////////////////////////////////////////////////////
// GetMonster()
//////////////////////////////////////////////////////
CMonster* CMyEngine::GetMonster()
{
    CMonster* m_pCurrentMonster = new CMonster();
	int temp = rand()%100;

	if(temp <= 50)
	{
    m_pCurrentMonster->SetName("Ogre");
    m_pCurrentMonster->SetMaxHitPoints(20);
    m_pCurrentMonster->SetRemainingHitPoints(20);
    m_pCurrentMonster->SetMaxAttackDamage(5);
    m_pCurrentMonster->SetExperienceValue(1);
    m_pCurrentMonster->SetMaxGold(20);
    m_Direct3D.CreateMonsterTextures("Graphics\\Ogre1.bmp", 
        "Graphics\\Ogre2.bmp", "Graphics\\Ogre3.bmp", 
        "Graphics\\Ogre4.bmp");
	}
	else
	{
	m_pCurrentMonster->SetName("Snake");
    m_pCurrentMonster->SetMaxHitPoints(10);
    m_pCurrentMonster->SetRemainingHitPoints(10);
    m_pCurrentMonster->SetMaxAttackDamage(7);
    m_pCurrentMonster->SetExperienceValue(1);
    m_pCurrentMonster->SetMaxGold(25);
    m_Direct3D.CreateMonsterTextures("Graphics\\SnakeA.bmp", 
        "Graphics\\SnakeB.bmp", "Graphics\\SnakeC.bmp", 
        "Graphics\\SnakeD.bmp");
	}//end else
    return m_pCurrentMonster;
}

//////////////////////////////////////////////////////
// ReleaseMonster()
//////////////////////////////////////////////////////
void CMyEngine::ReleaseMonster()
{
    if (m_pCurrentMonster)
    {
        delete m_pCurrentMonster;
        m_pCurrentMonster = NULL;
        m_Direct3D.ReleaseMonsterTextures();
    }
}

//////////////////////////////////////////////////////
// SaveGame()
//////////////////////////////////////////////////////
void CMyEngine::SaveGame(BOOL bFullSave)
{
    SaveMapFile(bFullSave);
    char dir[10];
    if (bFullSave)
        strcpy(dir, "Save");
    else
        strcpy(dir, "Temp");
    char fileName[MAX_PATH];
    wsprintf(fileName, "%s\\SaveFile.dat", dir);
    std::ofstream SaveFile(fileName);

    // Save quest flags.
    SaveFile << bSpokeToGrewell << '\n';
    SaveFile << bSpokeToWillam << '\n';
    SaveFile << bWillamQuestComplete << '\n';
    SaveFile << bHasWillamKey << '\n';

    // save player stats.
    SaveFile << m_Player.GetArmor() << '\n';
    SaveFile << m_Player.GetExperience() << '\n';
    SaveFile << m_Player.GetGold() << '\n';
    SaveFile << m_Player.GetHitPoints() << '\n';
    SaveFile << m_Player.GetKeys() << '\n';
    SaveFile << m_Player.GetMaxHitPoints() << '\n';
    SaveFile << m_Player.GetPotions() << '\n';
    SaveFile << m_Player.GetSector() << '\n';
    SaveFile << m_Player.GetWeapon() << '\n';
	SaveFile << m_Player.GetAntidotes() << '\n';

    // Save Map info.
    SaveFile << m_pstrCurrentMapFile << '\n';
    SaveFile << GetCurrentMap() << '\n';

    SaveFile.close();
    if (bFullSave)
        TurnOnPlaque("Game Saved");
}

//////////////////////////////////////////////////////
// LoadGame()
//////////////////////////////////////////////////////
void CMyEngine::LoadGame()
{
    char buf[128];
    std::ifstream SaveFile("Save\\SaveFile.dat", std::ios::binary);

    // Load quest flags.
    GetStringFromFile(SaveFile, buf);
    bSpokeToGrewell = atoi(buf);
    GetStringFromFile(SaveFile, buf);
    bSpokeToWillam = atoi(buf);
    GetStringFromFile(SaveFile, buf);
    bWillamQuestComplete = atoi(buf);
    GetStringFromFile(SaveFile, buf);
    bHasWillamKey = atoi(buf);

    // Load player stats.
    GetStringFromFile(SaveFile, buf);
    m_Player.SetArmor(atoi(buf));
    GetStringFromFile(SaveFile, buf);
    m_Player.SetExperience(atoi(buf));
    GetStringFromFile(SaveFile, buf);
    m_Player.SetGold(atoi(buf));
    GetStringFromFile(SaveFile, buf);
    m_Player.SetHitPoints(atoi(buf));
    GetStringFromFile(SaveFile, buf);
    m_Player.SetKeys(atoi(buf));
    GetStringFromFile(SaveFile, buf);
    m_Player.SetMaxHitPoints(atoi(buf));
    GetStringFromFile(SaveFile, buf);
    m_Player.SetPotions(atoi(buf));
    GetStringFromFile(SaveFile, buf);
    m_Player.SetSector(atoi(buf));
    GetStringFromFile(SaveFile, buf);
    m_Player.SetWeapon(atoi(buf));
	GetStringFromFile(SaveFile, buf);
    m_Player.SetAntidotes(atoi(buf));

    // Load map info.
    GetStringFromFile(SaveFile, buf);
    strcpy(m_pstrCurrentMapFile, buf);
    GetStringFromFile(SaveFile, buf);
    SetCurrentMap(atoi(buf));

    SaveFile.close();
    OpenMapFiles(m_pstrCurrentMapFile, FALSE);
    switch (m_byMapType)
    {
    case TOWNEXTERIOR:
        GetCDirect3DObj()->SetCurrentTileSurface
            (GetCDirect3DObj()->GetTownExtTileSurface());
        break;
    case TOWNINTERIOR:
        GetCDirect3DObj()->SetCurrentTileSurface
            (GetCDirect3DObj()->GetTownIntTileSurface());
        break;
    case DUNGEON:
        GetCDirect3DObj()->SetCurrentTileSurface
            (GetCDirect3DObj()->GetDungeonTileSurface());
        break;
    case WILDERNESS:
        GetCDirect3DObj()->SetCurrentTileSurface
            (GetCDirect3DObj()->GetWildernessTileSurface());
        break;
    }

    DeleteTempFiles();
    CopySaveToTemp();
    ResetAnimation();
    TurnOnPlaque("Game Loaded");
}

//////////////////////////////////////////////////////
// HandleKeys()
//////////////////////////////////////////////////////
void CMyEngine::HandleKeys(WPARAM wParam)
{
    switch (wParam)
    {
    case VK_ESCAPE:
    case VK_SPACE:
    case 73: //I
        if (!m_bBuyingPotion && !m_bBuyingArmor && !m_bBuyingWeapon)
            CEngine::HandleKeys(wParam);
        break;
    default:
        CEngine::HandleKeys(wParam);
    }
}

//////////////////////////////////////////////////////
// HandleN()
//////////////////////////////////////////////////////
void CMyEngine::HandleN()
{
    if (m_bBuyingPotion)
    {
        m_bBuyingPotion = FALSE;
        TurnOffPlaque();
    }
    else if (m_bBuyingArmor)
    {
        m_bBuyingArmor = FALSE;
        TurnOffPlaque();
    }
    else if (m_bBuyingWeapon)
    {
        m_bBuyingWeapon = FALSE;
        TurnOffPlaque();
    }
    else if (m_bRentingRoom)
    {
        m_bRentingRoom = FALSE;
        TurnOffPlaque();
    }
    else
        CEngine::HandleN();
}

//////////////////////////////////////////////////////
// HandleY()
//////////////////////////////////////////////////////
void CMyEngine::HandleY()
{
    if (m_bBuyingPotion)
        HandleBuyingPotion();
    else if (m_bBuyingArmor)
        HandleBuyingArmor();
    else if (m_bBuyingWeapon)
        HandleBuyingWeapon();
    else if (m_bRentingRoom)
        HandleRentingRoom();
    else
        CEngine::HandleY();
}

//////////////////////////////////////////////////////
// HandleBuyingPotion()
//////////////////////////////////////////////////////
void CMyEngine::HandleBuyingPotion()
{
    if (m_Player.GetGold() >= m_iPurchasePrice)
    {
        m_Player.SetGold(m_Player.GetGold() - m_iPurchasePrice);
        m_Player.SetPotions(m_Player.GetPotions() + 1);
        char msg[80];
        wsprintf(msg, "You buy 1 potion for %d gold.", m_iPurchasePrice);
        TurnOnPlaque(msg);
    }
    else
        TurnOnPlaque("You don't have enough gold.");
    m_bBuyingPotion = FALSE;
}

//////////////////////////////////////////////////////
// HandleBuyingArmor()
//////////////////////////////////////////////////////
void CMyEngine::HandleBuyingArmor()
{
    if (m_Player.GetGold() >= m_iPurchasePrice)
    {
        m_Player.SetGold(m_Player.GetGold() - m_iPurchasePrice);
        m_Player.SetArmor(m_iNewArmorLevel);
        char msg[80];
        wsprintf(msg, "You buy level %d armor for %d gold.", 
            m_iNewArmorLevel, m_iPurchasePrice);
        TurnOnPlaque(msg);
    }
    else
        TurnOnPlaque("You don't have enough gold.");
    m_bBuyingArmor = FALSE;
}

//////////////////////////////////////////////////////
// HandleBuyingWeapon()
//////////////////////////////////////////////////////
void CMyEngine::HandleBuyingWeapon()
{
    if (m_Player.GetGold() >= m_iPurchasePrice)
    {
        m_Player.SetGold(m_Player.GetGold() - m_iPurchasePrice);
        m_Player.SetWeapon(m_iNewWeaponLevel);
        char msg[80];
        wsprintf(msg, "You buy a level %d weapon for %d gold.", 
            m_iNewWeaponLevel, m_iPurchasePrice);
        TurnOnPlaque(msg);
    }
    else
        TurnOnPlaque("You don't have enough gold.");
    m_bBuyingWeapon = FALSE;
}

//////////////////////////////////////////////////////
// HandleRentingRoom()
//////////////////////////////////////////////////////
void CMyEngine::HandleRentingRoom()
{
    if (m_Player.GetGold() >= m_iPurchasePrice)
    {
        m_Player.SetGold(m_Player.GetGold() - m_iPurchasePrice);
        m_Player.SetHitPoints(m_Player.GetMaxHitPoints());
        TurnOnPlaque("You have a peaceful night's rest.");
    }
    else
        TurnOnPlaque("You don't have enough gold.");
    m_bRentingRoom = FALSE;
}

//////////////////////////////////////////////////////
// SetPurchasePrice()
//////////////////////////////////////////////////////
void CMyEngine::SetPurchasePrice(int iPrice)
{
    m_iPurchasePrice = iPrice;
}

//////////////////////////////////////////////////////
// SetNewWeaponLevel()
//////////////////////////////////////////////////////
void CMyEngine::SetNewWeaponLevel(int iLevel)
{
    m_iNewWeaponLevel = iLevel;
}

//////////////////////////////////////////////////////
// SetNewArmorLevel()
//////////////////////////////////////////////////////
void CMyEngine::SetNewArmorLevel(int iLevel)
{
    m_iNewArmorLevel = iLevel;
}
