//////////////////////////////////////////////////////
// MyEngine.h
//////////////////////////////////////////////////////

#pragma once

#include "Engine.h"
#include "FirstTown.h"
#include "Ganjek.h"
#include "Verisia.h"       //wilderness
#include "Verisiaville.h"  //new town
#include "Monster.h"
#include "MaximCastle.h"   //castle
// Quest flags defined in FirstTown.cpp.
extern BOOL bSpokeToGrewell;
extern BOOL bSpokeToWillam;
extern BOOL bWillamQuestComplete;
extern BOOL bHasWillamKey;


class CMyEngine : public CEngine
{
protected:
    // Shop flags.
    BOOL m_bBuyingPotion;
    BOOL m_bBuyingArmor;
    BOOL m_bBuyingWeapon;
    BOOL m_bRentingRoom;
    int m_iPurchasePrice;
    int m_iNewArmorLevel;
    int m_iNewWeaponLevel;

public:
    CMyEngine(char* pstrMap, int iMapType, int iSector);
    ~CMyEngine(void);

    void RespondToPlayerLocation();
    BOOL IsMonsterLocation();
    CMonster* GetMonster();
    void ReleaseMonster();
    void SaveGame(BOOL bShowMessage);
    void LoadGame();
    virtual void HandleKeys(WPARAM wParam);
    void SetPurchasePrice(int iPrice);
    void SetNewWeaponLevel(int iLevel);
    void SetNewArmorLevel(int iLevel);

protected:
    virtual void HandleNPC(int iNPC);
    virtual BOOL HandleContainer(int iSector);
    virtual BOOL HandleDoor(int iSector);
    virtual void HandleN();
    virtual void HandleY();
    void HandleBuyingPotion();
    void HandleBuyingArmor();
    void HandleBuyingWeapon();
    void HandleRentingRoom();
};
