#include "constants.h"
#include "MyEngine.h"
#include "verisiaville.h"

extern CMyEngine g_Engine;
const VERISIAARMORYENTRANCE     = 1272;
const VERISIAPOTIONSHOPENTRANCE = 1331;
const VERISIAINNENTRANCE        = 998;

void HandleVerisiaville()
{
switch (g_Engine.GetPlayer()->GetSector())
    {
    case VERISIAEXIT:
		g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(818);
        g_Engine.OpenMapFiles("Verisia.map", FALSE);
        g_Engine.SetCurrentMap(VERISIA);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetWildernessTileSurface());
        g_Engine.ResetAnimation();
        break;

	case VERISIAARMORYENTRANCE:
		g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(1271);
        g_Engine.OpenMapFiles("ArmorInside.map", FALSE);
        g_Engine.SetCurrentMap(ARMORSHOP);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownIntTileSurface());
        g_Engine.ResetAnimation();
        break;

	case VERISIAPOTIONSHOPENTRANCE:
		g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(1332);
        g_Engine.OpenMapFiles("PotionInside.map", FALSE);
        g_Engine.SetCurrentMap(POTIONSHOP);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownIntTileSurface());
        g_Engine.ResetAnimation();
        break;

	case VERISIAINNENTRANCE:
		g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(999);
        g_Engine.OpenMapFiles("InnInside.map", FALSE);
        g_Engine.SetCurrentMap(INN);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownIntTileSurface());
        g_Engine.ResetAnimation();
        break;
	}//end switch
}


//--------------------------------------//
//---------| HandleArmorShop()| --------//
//--------------------------------------//
void HandleArmorShop()
{
	switch(g_Engine.GetPlayer()->GetSector())
	{
	case VERISIAARMORYENTRANCE:
		g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(1273);
        g_Engine.OpenMapFiles("Verisiaville.map", FALSE);
        g_Engine.SetCurrentMap(VERISIAVILLE);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownExtTileSurface());
        g_Engine.ResetAnimation();
        break;
	}//end switch

}//end armor shop

//--------------------------------------//
//---------| HandlePotionShop()| --------//
//--------------------------------------//
void HandlePotionShop()
{
	switch(g_Engine.GetPlayer()->GetSector())
	{
	case VERISIAPOTIONSHOPENTRANCE:
		g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(1330);
        g_Engine.OpenMapFiles("Verisiaville.map", FALSE);
        g_Engine.SetCurrentMap(VERISIAVILLE);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownExtTileSurface());
        g_Engine.ResetAnimation();
        break;
	}//end switch

}//end potion shop

//--------------------------------------//
//---------| HandleInn()| --------//
//--------------------------------------//
void HandleInn()
{
	switch(g_Engine.GetPlayer()->GetSector())
	{
	case VERISIAINNENTRANCE:
		g_Engine.SaveGame(FALSE);
        g_Engine.GetPlayer()->SetSector(997);
        g_Engine.OpenMapFiles("Verisiaville.map", FALSE);
        g_Engine.SetCurrentMap(VERISIAVILLE);
        g_Engine.GetCDirect3DObj()->SetCurrentTileSurface
            (g_Engine.GetCDirect3DObj()->GetTownExtTileSurface());
        g_Engine.ResetAnimation();
        break;
	}//end switch

}//end potion shop

// HANDLE ARMOR SELLER
void HandleArmorSeller()
{
	g_Engine.TurnOnPlaque("I'm Swash Buckler! \n\
		                  Welcome to the Armory.\n\
						  Would you like to purchase \n\
						  level 1 armor for 150 Gold? (Y/N)");
	g_Engine.SetPurchasePrice(150);
    g_Engine.SetNewArmorLevel(1);
}//end HandleArmorSeller

// HANDLE INN KEEPER
void HandleInnKeeper()
{
	g_Engine.TurnOnPlaque("I'm Sleepius Napnap\n\
						  Welcome to the Inn.\n\
						  Would you like to replinish your HP\n\
						  for 50 Gold? (Y/N)");
	g_Engine.SetPurchasePrice(50);
}

// HANDLE POTION SELLER
void HandlePotionSeller()
{
	g_Engine.TurnOnPlaque("I'm Healemup, the potion seller\n\
						  Would ye like a potion for \n\
						  10 Gold? (Y/N)");
	g_Engine.SetPurchasePrice(10);
}

//Handle NPC Malfus

void HandleMalfus()
{	
	static int malfusCount = 0; //init
	if(malfusCount == 0)
	{
	g_Engine.TurnOnPlaque("Hey, I'm Malfus... I hear there is a \n\
						  treasure in town!");
	malfusCount++;
	}
	else
	{
			g_Engine.TurnOnPlaque("I hear that Karnosys locked\n\
								  a powerful weapon\n\
								  in a chest somewhere in town!");
	}//end else
		
}

//Handle NPC Gypsum
void HandleGypsum()
{

	g_Engine.TurnOnPlaque("I'm Gypsum!  Please, kind sir! \n\
						  Go and defeat the monsters! \n\
						  Save my children from the plague!");

}

//Handle NPC Coriandor
void HandleCoriandor()
{
		g_Engine.TurnOnPlaque("I'm Coriandor, Chief Guard! \n\
							  Welcome to Verisiaville!");
}

//Handle NPC Jensen
void HandleJenson()
{
	g_Engine.TurnOnPlaque("I am Jenson! \n\
						  Welcome to our great town!");
}

//Handle NPC Corey
void HandleCorry()
{
	g_Engine.TurnOnPlaque("Sir, the people are dying!\n\
						  Please help!");
}